;     
MouseByteNumber DB 0
;   ,  
FirstByte       DB 0
SecondByte      DB 0
ThirdByte       DB 0
timer_ticks_com dd 0
;***************************************
;*      *
;***************************************
check_mouse_data_com1:
;        cmp     [com1_mouse_detected],0
;        je      @@EndMouseInterrupt
;   
        mov     DX,3F8h  ;[COMPortBaseAddr]
        add     DX,5         ;xFDh
        in      AL,DX
        test    AL,1   ; ?
        jz      @@Error
;  
        mov     DX,3F8h   ;[COMPortBaseAddr]   ;xF8h
        in      AL,DX
;    
        and     AL,01111111b

;     
        cmp     [MouseByteNumber],0
        je      @@FirstByte
        cmp     [MouseByteNumber],1
        je      @@SecondByte
        cmp     [MouseByteNumber],2
        je      @@ThirdByte
        jmp     @@Error

;    
@@FirstByte:
        test    AL,1000000b       ;  ?
        jz      @@Error
        mov     [FirstByte],AL
        inc     [MouseByteNumber] ; 
        jmp     @@EndMouseInterrupt
;    
@@SecondByte:
        test    AL,1000000b
        jnz     @@Error
        mov     [SecondByte],AL
        inc     [MouseByteNumber] ; 
        jmp     @@EndMouseInterrupt
;    
@@ThirdByte:
        test    AL,1000000b
        jnz     @@Error
        mov     [ThirdByte],AL    ; 
        mov     [MouseByteNumber],0
; (     ).
;      
        mov al,[FirstByte]   ;[0xfb01]
        mov ah,al
        shr al,3
        and al,2
        shr ah,5
        and ah,1
        add al,ah
        mov    [BTN_DOWN],al
        mov    [mouse_active],1
;    X   X
        mov     AL,[FirstByte]
        shl     AL,6
        or      AL,[SecondByte]
        cbw
        call    mouse_acceleration_com1
        add     AX,[MOUSE_X]    ;[XCoordinate]
        ;       
        ;   
        js      @@X1
        cmp     AX,[ScreenWidth]   ;ScreenLength
        jb      @@X2
        ;   X   
        mov     AX,[ScreenWidth]   ;ScreenLength-1
        dec     ax
        jmp     @@X2
@@X1:
       ;   X   
        xor     AX,AX
@@X2:
        mov     [MOUSE_X],AX     ;[XCoordinate]
        ;    Y   Y
        mov     AL,[FirstByte]
        and     AL,00001100b
        shl     AL,4
        or      AL,[ThirdByte]
        cbw
        call    mouse_acceleration_com1
        add     AX,[MOUSE_Y]   ;[YCoordinate]
        ;       
        ;   
        js      @@Y1
        cmp     AX,[ScreenHeight]  ;ScreenHeigth
        jb      @@Y2
        ;   X   
        mov     AX,[ScreenHeight] ;ScreenHeigth-1
        dec     ax
        jmp     @@Y2
@@Y1:
       ;   X   
        xor     AX,AX
@@Y2:
        mov     [MOUSE_Y],AX     ;[YCoordinate]
        mov   eax,[timer_ticks]
        mov   [timer_ticks_com],eax
        jmp     @@EndMouseInterrupt

@@Error:
;       
; ,     
        mov     [MouseByteNumber],0
@@EndMouseInterrupt:
        call  ready_for_next_irq
        ret

mouse_acceleration_com1:
        push    eax
        mov   eax,[timer_ticks]
        sub   eax,[timer_ticks_com]
        cmp   eax,[mouse_delay]
        pop    eax
        ja     @f
        imul  ax,[mouse_speed_factor]
@@:
        ret
